#lang imperative-syndicate/test-implementation
;; A client observing some part of the server's dataspace should cause
;; creation of an assertion of observation in that server's dataspace.

(require (only-in imperative-syndicate/lang activate))
(require imperative-syndicate/broker)

(assertion-struct presence (who))

(define test-address (broker-loopback-connection "test"))

(test-case
    [(activate imperative-syndicate/broker)

     (spawn #:name 'producer
            (during (broker-connected test-address)
              (assert (to-broker test-address (presence 'producer)))))

     (spawn #:name 'consumer
            (during (broker-connected test-address)
              (on (asserted (from-broker test-address (presence $who)))
                  (printf "~a joined\n" who))))

     (spawn #:name 'metaconsumer
            (during (broker-connected test-address)
              (on (asserted (from-broker test-address (observe (presence _))))
                  (printf "Someone cares about presence!\n"))))
     ]
  no-crashes
  (expected-output (set "producer joined"
                        "Someone cares about presence!")))
